//=============================================================================
// Character.cpp
//=============================================================================
#include "Stdinc.h"
#include "Character.h"


//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CCharacter::CCharacter(void)
	:m_nDispPicPtrn( STAND ), m_nAnimationPtrn(ANI_PTN_NONE), m_dwFrameCount( 0 ), m_nATBValue( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CCharacter::~CCharacter(void)
{
}
//-----------------------------------------------------------------------------
// Initialize
// 
//-----------------------------------------------------------------------------
BOOL CCharacter::Initialize( int nID, int nPosX, int nPosY )
{
	m_nID = nID;
	m_nDispPosX = m_nPosX = nPosX;
	m_nDispPosY = m_nPosY = nPosY;

	// wiGǂݍ
	int iRet = LoadDivGraph( m_lpzFileName, 15, 15, 1, 27, 27, m_nHandle ) ;
	if ( iRet != DX_SUCCESS )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", m_lpzFileName );
		return FALSE;
	}

	StartAnimation( ANI_PTN_WALK_AT_START );

	return TRUE;
}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
void CCharacter::SetName( const char *pName )
{
	strncpy_s( m_szName, pName, _countof(m_szName)-1 );
}
//-----------------------------------------------------------------------------
// StartAnimation
// Aj[Vp^[ݒ
//-----------------------------------------------------------------------------
void CCharacter::StartAnimation( int nPaternNo )
{
	m_nAnimationPtrn = nPaternNo;

	// Aj[VX^[gʒuݒ
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_WALK_AT_START:	// Jns
		m_nDispPosX = m_nPosX + 50;
		break;
	default:
		// {ʒuɖ߂
		m_nDispPosX = m_nPosX;
		m_nDispPosY = m_nPosY;
	}

	// t[JE^Zbg
	m_dwFrameCount = 0;

}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CCharacter::FrameMove( void )
{
	switch ( m_nAnimationPtrn )
	{
	case ANI_PTN_NONE:			// Aj[V
		m_nDispPicPtrn = STAND;
		break;
	case ANI_PTN_WALK_AT_START:	// Jns
		if ( m_dwFrameCount % 6  < 3 )
		{
			m_nDispPicPtrn = WALK_R;
			m_nDispPosX -= 1;
		}
		else
		{
			m_nDispPosX -= 1;
			m_nDispPicPtrn = STAND;
		}

		if ( m_dwFrameCount == 50 )
		{
			StartAnimation( ANI_PTN_NONE );
		}
		break;
	//ANI_PTN_ATTACK,				// U
	//ANI_PTN_ATTACK_BACK,		// U̖߂
	}

	// ATBl
	IncreaseATBValue( m_dwFrameCount );

	m_dwFrameCount ++;
}
//-----------------------------------------------------------------------------
// Render
// _O
//-----------------------------------------------------------------------------
void CCharacter::Render( void )
{
	// g`
	DrawGraph( m_nDispPosX, m_nDispPosY, m_nHandle[m_nDispPicPtrn], TRUE );
}
//-----------------------------------------------------------------------------
// IncreaseATBValue
// ATBl
//-----------------------------------------------------------------------------
void CCharacter::IncreaseATBValue( DWORD dwFrameCount )
{
	if ( dwFrameCount % 5 == 1 )
	{
		// Xe[^Xɉ ATBlXV
		if ( m_nATBValue < ATB_VALUE_MAX )
		{
			++ m_nATBValue;
		}
		else
		{
			m_nATBValue = ATB_VALUE_MAX;
		}
	}
}
