//=============================================================================
// DisplayManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleSystem.h"
#include "DisplayManager.h"
#include "EnemyPartyWindow.h"
#include "PlayerPartyWindow.h"
#include "Field.h"
#include "Character.h"
#include "Enemy.h"
#include "Manipulator.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CDisplayManager::CDisplayManager(void)
	:m_pPartyWnd( NULL ), m_pEnemyPtWnd( NULL ), m_nCursorMode( CORSOR_MODE_NONE ),
	m_nCurPosX( 0 ), m_nCurPosY( 0 )

{

}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CDisplayManager::~CDisplayManager(void)
{
	if ( m_pEnemyPtWnd )
	{
		delete m_pEnemyPtWnd;
	}
	if ( m_pPartyWnd )
	{
		delete m_pPartyWnd;
	}
}
//-----------------------------------------------------------------------------
// Initialize
// 
//-----------------------------------------------------------------------------
BOOL CDisplayManager::Initialize( CCharacter **pPlayerParty, CEnemy **pEnemyParty, int nEnemyCount, CField *pField )
{
	// Qƃ|C^ۑ
	m_pField = pField;

	memcpy( m_pPlayerParty, pPlayerParty, sizeof(m_pPlayerParty) );
	memcpy( m_pEnemyParty, pEnemyParty, sizeof(m_pEnemyParty) );
	m_nEnemyCount = nEnemyCount;

	// J[\ǂݍ
	m_nCursorHandle = LoadGraph( CURSOR_FILE_NAME ) ;
	if ( m_nCursorHandle == DX_FAILED )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", CURSOR_FILE_NAME);
		return FALSE;
	}
#if 0
	// eXgEBhE
	m_pTestMsg = new CMsgWindow(); 
	m_pTestMsg->Create( 10/*X*/, 10/*Y*/, 620/**/, 440/**/ );
	m_pTestMsg->SetMessage("eXgS");
	m_lstWnd.push_back( m_pTestMsg );
//#else
	// eXgEBhE
	m_pTestMsg = new CMsgWindow(); 
	m_pTestMsg->Create( 0/*X*/, 170/*Y*/, 130/**/, 70/**/ );
	m_pTestMsg->SetMessage("WString|C^Ă镶 ColorFŕ`悵܂ sюQƕʒui߂");
	m_lstWnd.push_back( m_pTestMsg );
#else

	// Gp[eB\EBhE
	m_pEnemyPtWnd = new CEnemyPartyWindow();
	m_pEnemyPtWnd->Create( 0/*X*/, 170/*Y*/, 130/**/, 70/**/, pEnemyParty, nEnemyCount );
	m_lstWnd.push_back( m_pEnemyPtWnd );

	// p[eB\EBhE
	m_pPartyWnd = new CPlayerPartyWindow();
	m_pPartyWnd->Create( 130/*X*/, 170/*Y*/, 190/**/, 70/**/, pPlayerParty );
	m_lstWnd.push_back( m_pPartyWnd );

	// ANeBuEBhE
	m_pActiveWnd = m_pPartyWnd;


#endif
	return TRUE;
}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CDisplayManager::FrameMove( CManipulator *pMani )
{
	// XV
	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		m_pPlayerParty[iCnt]->FrameMove();
	}

	// p[eBEBhEXV
	m_pPartyWnd->FrameMove();

	// Gp[eBXgXV
	m_pEnemyPtWnd->FrameMove();

	// J[\
	CursorProc( pMani );

}
//-----------------------------------------------------------------------------
// CursorProc
// J[\
//-----------------------------------------------------------------------------
void CDisplayManager::CursorProc( CManipulator *pMani )
{
	switch ( m_nCursorMode )
	{
	case CORSOR_MODE_NONE:				// J[\
	{
		// v[ ATBl~ϑ҂
		for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
		{
			if ( m_pPlayerParty[iCnt]->m_nATBValue == ATB_VALUE_MAX )
			{	// v[I
				m_nCursorMode = CURSOR_MODE_PLAYER_SELECT;
				m_nCursorIndex = iCnt;	// IndexL
				m_nCurPosX = m_pPlayerParty[iCnt]->m_nPosX - 17;
				m_nCurPosY = m_pPlayerParty[iCnt]->m_nPosY +  4;
				break;
			}
		}
		break;
	}
	case CURSOR_MODE_PLAYER_SELECT:		// v[I
	{	// ㉺L[Ńv[I

		// L[
		if ( pMani->GetKeyPushCnt( KEY_INPUT_UP ) == 1 )
		{
			if ( m_nCursorIndex == 0 )
			{	// ԏȂ牽Ȃ
				break;
			}
			// ATBl܂L邩`FbN
			for ( int iCnt = m_nCursorIndex-1; 0 <= iCnt;  iCnt -- )
			{
				if ( m_pPlayerParty[iCnt]->m_nATBValue == ATB_VALUE_MAX )
				{
					m_nCursorMode = CURSOR_MODE_PLAYER_SELECT;
					m_nCursorIndex = iCnt;	// IndexL
					m_nCurPosX = m_pPlayerParty[iCnt]->m_nPosX - 17;
					m_nCurPosY = m_pPlayerParty[iCnt]->m_nPosY +  4;
					break;	// for
				}
			}
		}
		// L[
		if ( pMani->GetKeyPushCnt( KEY_INPUT_DOWN ) == 1 )
		{
			if ( BATTLE_CHAR_COUNT_MAX - 1 <= m_nCursorIndex )
			{	// ԉȂ牽Ȃ
				break;
			}

			// ATBl܂L邩`FbN
			for ( int iCnt = m_nCursorIndex+1; iCnt < BATTLE_CHAR_COUNT_MAX;  iCnt ++ )
			{
				if ( m_pPlayerParty[iCnt]->m_nATBValue == ATB_VALUE_MAX )
				{
					m_nCursorMode = CURSOR_MODE_PLAYER_SELECT;
					m_nCursorIndex = iCnt;	// IndexL
					m_nCurPosX = m_pPlayerParty[iCnt]->m_nPosX - 17;
					m_nCurPosY = m_pPlayerParty[iCnt]->m_nPosY +  4;
					break;	// for
				}
			}
		}

		// {^Ńj[J
		break;
	}
	case CURSOR_MODE_ENEMY_SELECT:		// GI
		break;
	}
}
//-----------------------------------------------------------------------------
// Render
// ZI[_[`
//-----------------------------------------------------------------------------
void CDisplayManager::Render( void )
{
	using namespace std;

	// wi`
	m_pField->Render();

	// `
	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		m_pPlayerParty[iCnt]->Render();
	}

	// G`
	for ( int iCnt = 0; iCnt < m_nEnemyCount; iCnt ++ )
	{
		m_pEnemyParty[iCnt]->Render();
	}

	// EBhE`
	list<CFrameWindow *>::iterator it = m_lstWnd.begin();
	while( it != m_lstWnd.end() )
	{
		(*it)->Render();
		++it;
	}

	// J[\`
	if ( m_nCursorMode == CURSOR_MODE_PLAYER_SELECT || 
		 m_nCursorMode == CURSOR_MODE_ENEMY_SELECT )
	{
		// v[AGI J[\\
		DrawGraph( m_nCurPosX, m_nCurPosY, m_nCursorHandle, TRUE );
	}
}
