//=============================================================================
// DisplayManager.h
//=============================================================================
#pragma once
#include <list>
#include "FrameWindow.h"

class CField;
class CCharacter;
class CEnemyPartyWindow;
class CPlayerPartyWindow;

// J[\[h
enum {
	CORSOR_MODE_NONE = 0,			// J[\
	CURSOR_MODE_PLAYER_SELECT,		// ATB̂܂v[I
	CURSOR_MODE_PLAYER_COMMAND,		// v[R}hI
	CURSOR_MODE_PLAYER_MENU_ITEM,	// v[Ij[
	CURSOR_MODE_ENEMY_SELECT,		// R}hΏۓGI
};
//-----------------------------------------------------------------------------
// CDisplayManager
//-----------------------------------------------------------------------------
class CDisplayManager
{
protected:
	// VXe
	std::list<CFrameWindow *> m_lstWnd;		// \ǗXg
	CFrameWindow *m_pActiveWnd;				// ANeBu(L[͎)EBhE

	// EBhE
	CEnemyPartyWindow	*m_pEnemyPtWnd;		// Gp[eBEBhE

	CPlayerPartyWindow	*m_pPartyWnd;		// p[eB\EBhE
	CField				*m_pField;			// tB[h(Q)
	CCharacter			*m_pPlayerParty[BATTLE_CHAR_COUNT_MAX];		// p[eB(Q)
	CEnemy				*m_pEnemyParty[BATTLE_ENEMY_COUNT_MAX];		// Gp[eB(Q)
	int					m_nEnemyCount;		// G̐

	// J[\֌W
	int					m_nCursorHandle;	// J[\G
	int					m_nCursorMode;		// J[\[h
	int					m_nCurPosX;			// J[\ʒuX
	int					m_nCurPosY;			// J[\ʒuY
	int					m_nCursorIndex;		// CfbNX(p[eBo^G)


public:
	CDisplayManager(void);
	virtual ~CDisplayManager(void);

	BOOL Initialize( CCharacter **pPlayerParty, CEnemy **pEnemyParty, int nEnemyCount, CField *pField );
	void FrameMove( CManipulator *pMani );	// XV
	void CursorProc( CManipulator *pMani );	// J[\
	void Render( void );					// `
};

