//=============================================================================
// FrameWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "FrameWindow.h"


//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CFrameWindow::CFrameWindow(void)
: m_nPosX( 0 ), m_nPosY( 0 ), m_nWidth( CANVAS_WIDTH ), m_nHeight( CANVAS_HEIGHT )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CFrameWindow::~CFrameWindow(void)
{
}
//-----------------------------------------------------------------------------
// Create
// 
//-----------------------------------------------------------------------------
BOOL CFrameWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight )
{
	// EBhËʒu
	m_nPosX = iPosX;
	m_nPosY = iPosY;

	// EBhẼTCY
	m_nWidth = iWidth;
	m_nHeight= iHeight;

	// t[Gǂݍ
	int iRet = LoadDivGraph( WINDOW_FRAME_CHIPS_FILE_NAME , 8 , 9 , 1 , FRAME_CHIP_ONE_SIDE_SIZE, FRAME_CHIP_ONE_SIDE_SIZE , m_nHandle ) ;
	if ( iRet != DX_SUCCESS )
	{
		CUtility::tERROR("摜ǂݍݎs [%s]", WINDOW_FRAME_CHIPS_FILE_NAME);
		return FALSE;
	}

	// wi쐬
	CreateBackGroundGraph();

	return TRUE;
}
//-----------------------------------------------------------------------------
// CreateBackGroundGraph
// wiG쐬
//-----------------------------------------------------------------------------
void CFrameWindow::CreateBackGroundGraph( void )
{
	m_nHandle[ BACK_GROUND ] = MakeGraph( CANVAS_WIDTH, CANVAS_HEIGHT ) ;
	// `ύX
	SetDrawScreen( m_nHandle[ BACK_GROUND ] );

	const int nThickness = 8;	// 1Linȇ
	const int nInitR = 128;
	const int nInitG = 128;
	const int nInitB = 255;
	for ( int iCnt = 0; iCnt < CANVAS_HEIGHT; iCnt += nThickness )
	{	// FvZ

		int nR,nG,nB;
		// œ삪ς
		if ( iCnt < (CANVAS_HEIGHT/2) )
		{	// ԗ 128 -> 0
			nR = nInitR * (CANVAS_HEIGHT/2 - iCnt) / (CANVAS_HEIGHT/2);
			nG = nInitG * (CANVAS_HEIGHT/2 - iCnt) / (CANVAS_HEIGHT/2);
			nB = nInitB;
		}
		else
		{	//   255 -> 0
			nR = nG = 0;
			nB = nInitB - ((iCnt + nThickness) - CANVAS_HEIGHT/2);
		}
		// C`
		DWORD dwColor = GetColor( nR, nG, nB );
		DrawLine( 0, iCnt, CANVAS_WIDTH, iCnt, dwColor, nThickness );
	}
	// `߂
	SetDrawScreen( DX_SCREEN_BACK );
}
//-----------------------------------------------------------------------------
// Render
// g`
//-----------------------------------------------------------------------------
void CFrameWindow::Render( void )
{
	int iCountH = m_nWidth / FRAME_CHIP_ONE_SIDE_SIZE;		// `bv
	int iCountV = m_nHeight / FRAME_CHIP_ONE_SIDE_SIZE;		// `bv

	// wi
	DrawExtendGraph( m_nPosX, m_nPosY, m_nPosX + m_nWidth, m_nPosY + m_nHeight, m_nHandle[ BACK_GROUND ], FALSE );

	for ( int iCnt = 0; iCnt < iCountH; iCnt ++ )
	{
		int iPosX = m_nPosX + ( iCnt * FRAME_CHIP_ONE_SIDE_SIZE );
		// 
		DrawGraph( iPosX, m_nPosY , m_nHandle[ T_SIDE ], TRUE ) ;
		// 
		DrawGraph( iPosX, m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE , m_nHandle[ B_SIDE ], TRUE ) ;
	}
	// 
	for ( int iCnt = 0; iCnt < iCountV; iCnt ++ )
	{
		int iPosY = m_nPosY + ( iCnt * FRAME_CHIP_ONE_SIDE_SIZE );
		// 
		DrawGraph( m_nPosX, iPosY , m_nHandle[ L_SIDE ], TRUE ) ;
		// E
		DrawGraph( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, iPosY , m_nHandle[ R_SIDE ], TRUE ) ;
	}

	// 
	DrawGraph( m_nPosX , m_nPosY , m_nHandle[ L_T_CORNER ], TRUE ) ;
	// E
	DrawGraph( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, m_nPosY , m_nHandle[ R_T_CORNER ], TRUE ) ;
	// 
	DrawGraph( m_nPosX , m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE, m_nHandle[ L_B_CORNER ], TRUE ) ;
	// E
	DrawGraph( m_nPosX + m_nWidth - FRAME_CHIP_ONE_SIDE_SIZE, m_nPosY + m_nHeight - FRAME_CHIP_ONE_SIDE_SIZE , m_nHandle[ R_B_CORNER ], TRUE ) ;
}
