//=============================================================================
// PlayerPartyWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "PlayerPartyWindow.h"
#include "Character.h"
#include "AtbGauge.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CPlayerPartyWindow::CPlayerPartyWindow(void)
{
	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		m_pAtbGauge[iCnt] = new CAtbGauge();
	}
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CPlayerPartyWindow::~CPlayerPartyWindow(void)
{
	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		delete m_pAtbGauge[iCnt];
	}
}

//-----------------------------------------------------------------------------
// Create
//-----------------------------------------------------------------------------
BOOL CPlayerPartyWindow::Create( int iPosX, int iPosY, int iWidth, int iHeight, CCharacter **pPlayerParty )
{
	if ( !CFrameWindow::Create( iPosX, iPosY, iWidth, iHeight ) )
		return FALSE;

	// |C^ۑ
	memcpy( m_pPlayerParty, pPlayerParty, sizeof(m_pPlayerParty) );

	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		BOOL bRet;
		bRet = m_pAtbGauge[iCnt]->Create( m_nPosX + FRAME_TO_ATB_GAUGE_MARGINE_X, m_nPosY + FRAME_TO_NAME_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) ) );
		if ( !bRet )
		{
			return FALSE;
		}
		m_pAtbGauge[iCnt]->SetValue( 0 );
	}
	return TRUE;
}
//-----------------------------------------------------------------------------
// FrameMove
// t[XV
//-----------------------------------------------------------------------------
void CPlayerPartyWindow::FrameMove( void )
{
	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		m_pAtbGauge[iCnt]->SetValue( m_pPlayerParty[iCnt]->m_nATBValue );
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CPlayerPartyWindow::Render( void )
{
	// x[XNX`
	CFrameWindow::Render();

	for ( int iCnt = 0; iCnt < BATTLE_CHAR_COUNT_MAX; iCnt ++ )
	{
		int iPosY = m_nPosY + FRAME_TO_NAME_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		// O`
		DrawString( m_nPosX + FRAME_TO_NAME_MARGINE_X, iPosY, m_pPlayerParty[iCnt]->m_szName, STRING_COLOR );

		// HP`
		char szBuff[64];
		sprintf_s( szBuff, "%5d", m_pPlayerParty[iCnt]->m_nHP );
		DrawString( m_nPosX + FRAME_TO_HP_MARGINE_X, iPosY, szBuff, STRING_COLOR );

		// ATBQ[W`
		m_pAtbGauge[iCnt]->Render();
	}
}
